# generated by datamodel-codegen:
#   filename:  manifest_v10.json

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Any, Dict, List, Optional, Union

from pydantic import Extra, Field, constr

from dbt_artifacts_parser.parsers.base import BaseParserModel


class ManifestMetadata(BaseParserModel):
    class Config:
        extra = Extra.forbid

    dbt_schema_version: Optional[
        str
    ] = 'https://schemas.getdbt.com/dbt/manifest/v10.json'
    dbt_version: Optional[str] = '1.6.0b4'
    generated_at: Optional[datetime] = '2023-06-15T20:32:38.802488Z'
    invocation_id: Optional[Optional[str]] = 'fe95e4d0-61ff-487d-8293-092f543fcab2'
    env: Optional[Dict[str, str]] = {}
    project_name: Optional[Optional[str]] = Field(
        None, description='Name of the root project'
    )
    project_id: Optional[Optional[str]] = Field(
        None,
        description='A unique identifier for the project, hashed from the project name',
    )
    user_id: Optional[
        Optional[
            constr(
                regex=r'[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}'
            )
        ]
    ] = Field(None, description='A unique identifier for the user')
    send_anonymous_usage_stats: Optional[Optional[bool]] = Field(
        None, description='Whether dbt is configured to send anonymous usage statistics'
    )
    adapter_type: Optional[Optional[str]] = Field(
        None, description='The type name of the adapter'
    )


class ResourceType(Enum):
    analysis = 'analysis'


class FileHash(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    checksum: str


class OnConfigurationChange(Enum):
    apply = 'apply'
    continue_ = 'continue'
    fail = 'fail'


class Hook(BaseParserModel):
    class Config:
        extra = Extra.forbid

    sql: str
    transaction: Optional[bool] = True
    index: Optional[Optional[int]] = None


class Docs(BaseParserModel):
    class Config:
        extra = Extra.forbid

    show: Optional[bool] = True
    node_color: Optional[Optional[str]] = None


class ContractConfig(BaseParserModel):
    class Config:
        extra = Extra.forbid

    enforced: Optional[bool] = False


class Type(Enum):
    check = 'check'
    not_null = 'not_null'
    unique = 'unique'
    primary_key = 'primary_key'
    foreign_key = 'foreign_key'
    custom = 'custom'


class ColumnLevelConstraint(BaseParserModel):
    class Config:
        extra = Extra.forbid

    type: Type
    name: Optional[Optional[str]] = None
    expression: Optional[Optional[str]] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True


class RefArgs(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    package: Optional[Optional[str]] = None
    version: Optional[Optional[Union[str, float]]] = None


class DependsOn(BaseParserModel):
    class Config:
        extra = Extra.forbid

    macros: Optional[List[str]] = []
    nodes: Optional[List[str]] = []


class InjectedCTE(BaseParserModel):
    class Config:
        extra = Extra.forbid

    id: str
    sql: str


class Contract(BaseParserModel):
    class Config:
        extra = Extra.forbid

    enforced: Optional[bool] = False
    checksum: Optional[Optional[str]] = None


class ResourceType1(Enum):
    test = 'test'


class TestConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True
    alias: Optional[Optional[str]] = None
    schema_: Optional[Optional[str]] = Field('dbt_test__audit', alias='schema')
    database: Optional[Optional[str]] = None
    tags: Optional[Union[List[str], str]] = []
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    materialized: Optional[str] = 'test'
    severity: Optional[
        constr(regex=r'^([Ww][Aa][Rr][Nn]|[Ee][Rr][Rr][Oo][Rr])$')
    ] = 'ERROR'
    store_failures: Optional[Optional[bool]] = None
    where: Optional[Optional[str]] = None
    limit: Optional[Optional[int]] = None
    fail_calc: Optional[str] = 'count(*)'
    warn_if: Optional[str] = '!= 0'
    error_if: Optional[str] = '!= 0'


class ResourceType2(Enum):
    operation = 'operation'


class ResourceType3(Enum):
    model = 'model'


class Access(Enum):
    protected = 'protected'
    private = 'private'
    public = 'public'


class Type1(Enum):
    check = 'check'
    not_null = 'not_null'
    unique = 'unique'
    primary_key = 'primary_key'
    foreign_key = 'foreign_key'
    custom = 'custom'


class ModelLevelConstraint(BaseParserModel):
    class Config:
        extra = Extra.forbid

    type: Type1
    name: Optional[Optional[str]] = None
    expression: Optional[Optional[str]] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    columns: Optional[List[str]] = []


class StateRelation(BaseParserModel):
    class Config:
        extra = Extra.forbid

    alias: str
    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')


class ResourceType4(Enum):
    rpc = 'rpc'


class ResourceType5(Enum):
    sqloperation = 'sqloperation'


class ResourceType6(Enum):
    test = 'test'


class TestMetadata(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    kwargs: Optional[Dict[str, Any]] = {}
    namespace: Optional[Optional[str]] = None


class ResourceType7(Enum):
    snapshot = 'snapshot'


class OnConfigurationChange1(Enum):
    apply = 'apply'
    continue_ = 'continue'
    fail = 'fail'


class SnapshotConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True
    alias: Optional[Optional[str]] = None
    schema_: Optional[Optional[str]] = Field(None, alias='schema')
    database: Optional[Optional[str]] = None
    tags: Optional[Union[List[str], str]] = []
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    materialized: Optional[str] = 'snapshot'
    incremental_strategy: Optional[Optional[str]] = None
    persist_docs: Optional[Dict[str, Any]] = {}
    post_hook: Optional[List[Hook]] = Field([], alias='post-hook')
    pre_hook: Optional[List[Hook]] = Field([], alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = {}
    column_types: Optional[Dict[str, Any]] = {}
    full_refresh: Optional[Optional[bool]] = None
    unique_key: Optional[Optional[str]] = None
    on_schema_change: Optional[Optional[str]] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange1] = 'apply'
    grants: Optional[Dict[str, Any]] = {}
    packages: Optional[List[str]] = []
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    contract: Optional[ContractConfig] = {'enforced': False}
    strategy: Optional[Optional[str]] = None
    target_schema: Optional[Optional[str]] = None
    target_database: Optional[Optional[str]] = None
    updated_at: Optional[Optional[str]] = None
    check_cols: Optional[Optional[Union[str, List[str]]]] = None


class ResourceType8(Enum):
    seed = 'seed'


class OnConfigurationChange2(Enum):
    apply = 'apply'
    continue_ = 'continue'
    fail = 'fail'


class SeedConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True
    alias: Optional[Optional[str]] = None
    schema_: Optional[Optional[str]] = Field(None, alias='schema')
    database: Optional[Optional[str]] = None
    tags: Optional[Union[List[str], str]] = []
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    materialized: Optional[str] = 'seed'
    incremental_strategy: Optional[Optional[str]] = None
    persist_docs: Optional[Dict[str, Any]] = {}
    post_hook: Optional[List[Hook]] = Field([], alias='post-hook')
    pre_hook: Optional[List[Hook]] = Field([], alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = {}
    column_types: Optional[Dict[str, Any]] = {}
    full_refresh: Optional[Optional[bool]] = None
    unique_key: Optional[Optional[Union[str, List[str]]]] = None
    on_schema_change: Optional[Optional[str]] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange2] = 'apply'
    grants: Optional[Dict[str, Any]] = {}
    packages: Optional[List[str]] = []
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    contract: Optional[ContractConfig] = {'enforced': False}
    quote_columns: Optional[Optional[bool]] = None


class MacroDependsOn(BaseParserModel):
    class Config:
        extra = Extra.forbid

    macros: Optional[List[str]] = []


class ResourceType9(Enum):
    source = 'source'


class Quoting(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[bool]] = None
    schema_: Optional[Optional[bool]] = Field(None, alias='schema')
    identifier: Optional[Optional[bool]] = None
    column: Optional[Optional[bool]] = None


class PeriodEnum(Enum):
    minute = 'minute'
    hour = 'hour'
    day = 'day'


class Time(BaseParserModel):
    class Config:
        extra = Extra.forbid

    count: Optional[Optional[int]] = None
    period: Optional[Optional[PeriodEnum]] = None


class ExternalPartition(BaseParserModel):
    class Config:
        extra = Extra.allow

    name: Optional[str] = ''
    description: Optional[str] = ''
    data_type: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = {}


class SourceConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True


class ResourceType10(Enum):
    macro = 'macro'


class SupportedLanguage(Enum):
    python = 'python'
    sql = 'sql'


class MacroArgument(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    type: Optional[Optional[str]] = None
    description: Optional[str] = ''


class ResourceType11(Enum):
    doc = 'doc'


class Documentation(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    resource_type: ResourceType11
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    block_contents: str


class ResourceType12(Enum):
    exposure = 'exposure'


class Type2(Enum):
    dashboard = 'dashboard'
    notebook = 'notebook'
    analysis = 'analysis'
    ml = 'ml'
    application = 'application'


class MaturityEnum(Enum):
    low = 'low'
    medium = 'medium'
    high = 'high'


class Owner(BaseParserModel):
    class Config:
        extra = Extra.allow

    email: Optional[Optional[str]] = None
    name: Optional[Optional[str]] = None


class ExposureConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True


class ResourceType13(Enum):
    metric = 'metric'


class Type3(Enum):
    simple = 'simple'
    ratio = 'ratio'
    expr = 'expr'
    cumulative = 'cumulative'
    derived = 'derived'


class GrainToDateEnum(Enum):
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class WhereFilter(BaseParserModel):
    class Config:
        extra = Extra.forbid

    where_sql_template: str


class Granularity(Enum):
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class MetricTimeWindow(BaseParserModel):
    class Config:
        extra = Extra.forbid

    count: int
    granularity: Granularity


class OffsetToGrainEnum(Enum):
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class MetricInput(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    filter: Optional[Optional[WhereFilter]] = None
    alias: Optional[Optional[str]] = None
    offset_window: Optional[Optional[MetricTimeWindow]] = None
    offset_to_grain: Optional[Optional[OffsetToGrainEnum]] = None


class FileSlice(BaseParserModel):
    class Config:
        extra = Extra.forbid

    filename: str
    content: str
    start_line_number: int
    end_line_number: int


class MetricConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True
    group: Optional[Optional[str]] = None


class ResourceType14(Enum):
    group = 'group'


class Group(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    resource_type: ResourceType14
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    owner: Owner


class ResourceType15(Enum):
    model = 'model'
    analysis = 'analysis'
    test = 'test'
    snapshot = 'snapshot'
    operation = 'operation'
    seed = 'seed'
    rpc = 'rpc'
    sqloperation = 'sqloperation'
    doc = 'doc'
    source = 'source'
    macro = 'macro'
    exposure = 'exposure'
    metric = 'metric'
    group = 'group'
    semanticmodel = 'semanticmodel'


class NodeRelation(BaseParserModel):
    class Config:
        extra = Extra.forbid

    alias: str
    schema_name: str
    database: Optional[Optional[str]] = None


class Defaults(BaseParserModel):
    class Config:
        extra = Extra.forbid

    agg_time_dimension: Optional[Optional[str]] = None


class Type4(Enum):
    foreign = 'foreign'
    natural = 'natural'
    primary = 'primary'
    unique = 'unique'


class Entity(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    type: Type4
    description: Optional[Optional[str]] = None
    role: Optional[Optional[str]] = None
    expr: Optional[Optional[str]] = None


class Agg(Enum):
    sum = 'sum'
    min = 'min'
    max = 'max'
    count_distinct = 'count_distinct'
    sum_boolean = 'sum_boolean'
    average = 'average'
    percentile = 'percentile'
    median = 'median'
    count = 'count'


class MeasureAggregationParameters(BaseParserModel):
    class Config:
        extra = Extra.forbid

    percentile: Optional[Optional[float]] = None
    use_discrete_percentile: Optional[Optional[bool]] = None
    use_approximate_percentile: Optional[Optional[bool]] = None


class WindowChoice(Enum):
    sum = 'sum'
    min = 'min'
    max = 'max'
    count_distinct = 'count_distinct'
    sum_boolean = 'sum_boolean'
    average = 'average'
    percentile = 'percentile'
    median = 'median'
    count = 'count'


class NonAdditiveDimension(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    window_choice: WindowChoice
    window_grouples: List[str]


class Type5(Enum):
    categorical = 'categorical'
    time = 'time'


class TimeGranularity(Enum):
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class DimensionValidityParams(BaseParserModel):
    class Config:
        extra = Extra.forbid

    is_start: Optional[bool] = False
    is_end: Optional[bool] = False


class NodeConfig(BaseParserModel):
    class Config:
        extra = Extra.allow

    enabled: Optional[bool] = True
    alias: Optional[Optional[str]] = None
    schema_: Optional[Optional[str]] = Field(None, alias='schema')
    database: Optional[Optional[str]] = None
    tags: Optional[Union[List[str], str]] = []
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[Optional[str]] = None
    persist_docs: Optional[Dict[str, Any]] = {}
    post_hook: Optional[List[Hook]] = Field([], alias='post-hook')
    pre_hook: Optional[List[Hook]] = Field([], alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = {}
    column_types: Optional[Dict[str, Any]] = {}
    full_refresh: Optional[Optional[bool]] = None
    unique_key: Optional[Optional[Union[str, List[str]]]] = None
    on_schema_change: Optional[Optional[str]] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = 'apply'
    grants: Optional[Dict[str, Any]] = {}
    packages: Optional[List[str]] = []
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    contract: Optional[ContractConfig] = {'enforced': False}


class ColumnInfo(BaseParserModel):
    class Config:
        extra = Extra.allow

    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = {}
    data_type: Optional[Optional[str]] = None
    constraints: Optional[List[ColumnLevelConstraint]] = []
    quote: Optional[Optional[bool]] = None
    tags: Optional[List[str]] = []


class SingularTestNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType1
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[TestConfig] = {
        'enabled': True,
        'alias': None,
        'schema': 'dbt_test__audit',
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'test',
        'severity': 'ERROR',
        'store_failures': None,
        'where': None,
        'limit': None,
        'fail_calc': 'count(*)',
        'warn_if': '!= 0',
        'error_if': '!= 0',
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.805745
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}


class HookNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType2
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[NodeConfig] = {
        'enabled': True,
        'alias': None,
        'schema': None,
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'view',
        'incremental_strategy': None,
        'persist_docs': {},
        'quoting': {},
        'column_types': {},
        'full_refresh': None,
        'unique_key': None,
        'on_schema_change': 'ignore',
        'on_configuration_change': 'apply',
        'grants': {},
        'packages': [],
        'docs': {'show': True, 'node_color': None},
        'contract': {'enforced': False},
        'post-hook': [],
        'pre-hook': [],
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.806452
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}
    index: Optional[Optional[int]] = None


class ModelNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType3
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[NodeConfig] = {
        'enabled': True,
        'alias': None,
        'schema': None,
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'view',
        'incremental_strategy': None,
        'persist_docs': {},
        'quoting': {},
        'column_types': {},
        'full_refresh': None,
        'unique_key': None,
        'on_schema_change': 'ignore',
        'on_configuration_change': 'apply',
        'grants': {},
        'packages': [],
        'docs': {'show': True, 'node_color': None},
        'contract': {'enforced': False},
        'post-hook': [],
        'pre-hook': [],
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.807143
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}
    access: Optional[Access] = 'protected'
    constraints: Optional[List[ModelLevelConstraint]] = []
    version: Optional[Optional[Union[str, float]]] = None
    latest_version: Optional[Optional[Union[str, float]]] = None
    deprecation_date: Optional[Optional[datetime]] = None
    state_relation: Optional[Optional[StateRelation]] = None


class RPCNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType4
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[NodeConfig] = {
        'enabled': True,
        'alias': None,
        'schema': None,
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'view',
        'incremental_strategy': None,
        'persist_docs': {},
        'quoting': {},
        'column_types': {},
        'full_refresh': None,
        'unique_key': None,
        'on_schema_change': 'ignore',
        'on_configuration_change': 'apply',
        'grants': {},
        'packages': [],
        'docs': {'show': True, 'node_color': None},
        'contract': {'enforced': False},
        'post-hook': [],
        'pre-hook': [],
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.808148
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}


class SqlNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType5
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[NodeConfig] = {
        'enabled': True,
        'alias': None,
        'schema': None,
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'view',
        'incremental_strategy': None,
        'persist_docs': {},
        'quoting': {},
        'column_types': {},
        'full_refresh': None,
        'unique_key': None,
        'on_schema_change': 'ignore',
        'on_configuration_change': 'apply',
        'grants': {},
        'packages': [],
        'docs': {'show': True, 'node_color': None},
        'contract': {'enforced': False},
        'post-hook': [],
        'pre-hook': [],
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.8088078
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}


class GenericTestNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    test_metadata: TestMetadata
    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType6
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[TestConfig] = {
        'enabled': True,
        'alias': None,
        'schema': 'dbt_test__audit',
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'test',
        'severity': 'ERROR',
        'store_failures': None,
        'where': None,
        'limit': None,
        'fail_calc': 'count(*)',
        'warn_if': '!= 0',
        'error_if': '!= 0',
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.8095539
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}
    column_name: Optional[Optional[str]] = None
    file_key_name: Optional[Optional[str]] = None
    attached_node: Optional[Optional[str]] = None


class SnapshotNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType7
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: SnapshotConfig
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.810841
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}
    state_relation: Optional[Optional[StateRelation]] = None


class SeedNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType8
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[SeedConfig] = {
        'enabled': True,
        'alias': None,
        'schema': None,
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'seed',
        'incremental_strategy': None,
        'persist_docs': {},
        'quoting': {},
        'column_types': {},
        'full_refresh': None,
        'unique_key': None,
        'on_schema_change': 'ignore',
        'on_configuration_change': 'apply',
        'grants': {},
        'packages': [],
        'docs': {'show': True, 'node_color': None},
        'contract': {'enforced': False},
        'quote_columns': None,
        'post-hook': [],
        'pre-hook': [],
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.812035
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    root_path: Optional[Optional[str]] = None
    depends_on: Optional[MacroDependsOn] = {'macros': []}
    state_relation: Optional[Optional[StateRelation]] = None


class FreshnessThreshold(BaseParserModel):
    class Config:
        extra = Extra.forbid

    warn_after: Optional[Optional[Time]] = {'count': None, 'period': None}
    error_after: Optional[Optional[Time]] = {'count': None, 'period': None}
    filter: Optional[Optional[str]] = None


class ExternalTable(BaseParserModel):
    class Config:
        extra = Extra.allow

    location: Optional[Optional[str]] = None
    file_format: Optional[Optional[str]] = None
    row_format: Optional[Optional[str]] = None
    tbl_properties: Optional[Optional[str]] = None
    partitions: Optional[Optional[Union[List[str], List[ExternalPartition]]]] = None


class Macro(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    resource_type: ResourceType10
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    macro_sql: str
    depends_on: Optional[MacroDependsOn] = {'macros': []}
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = {}
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    arguments: Optional[List[MacroArgument]] = []
    created_at: Optional[float] = 1686861158.8135822
    supported_languages: Optional[Optional[List[SupportedLanguage]]] = None


class Exposure(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    resource_type: ResourceType12
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    type: Type2
    owner: Owner
    description: Optional[str] = ''
    label: Optional[Optional[str]] = None
    maturity: Optional[Optional[MaturityEnum]] = None
    meta: Optional[Dict[str, Any]] = {}
    tags: Optional[List[str]] = []
    config: Optional[ExposureConfig] = {'enabled': True}
    unrendered_config: Optional[Dict[str, Any]] = {}
    url: Optional[Optional[str]] = None
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    created_at: Optional[float] = 1686861158.814228


class MetricInputMeasure(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    filter: Optional[Optional[WhereFilter]] = None
    alias: Optional[Optional[str]] = None


class SourceFileMetadata(BaseParserModel):
    class Config:
        extra = Extra.forbid

    repo_file_path: str
    file_slice: FileSlice


class Measure(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    agg: Agg
    description: Optional[Optional[str]] = None
    create_metric: Optional[bool] = False
    expr: Optional[Optional[str]] = None
    agg_params: Optional[Optional[MeasureAggregationParameters]] = None
    non_additive_dimension: Optional[Optional[NonAdditiveDimension]] = None
    agg_time_dimension: Optional[Optional[str]] = None


class DimensionTypeParams(BaseParserModel):
    class Config:
        extra = Extra.forbid

    time_granularity: TimeGranularity
    validity_params: Optional[Optional[DimensionValidityParams]] = None


class AnalysisNode(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: FileHash
    config: Optional[NodeConfig] = {
        'enabled': True,
        'alias': None,
        'schema': None,
        'database': None,
        'tags': [],
        'meta': {},
        'group': None,
        'materialized': 'view',
        'incremental_strategy': None,
        'persist_docs': {},
        'quoting': {},
        'column_types': {},
        'full_refresh': None,
        'unique_key': None,
        'on_schema_change': 'ignore',
        'on_configuration_change': 'apply',
        'grants': {},
        'packages': [],
        'docs': {'show': True, 'node_color': None},
        'contract': {'enforced': False},
        'post-hook': [],
        'pre-hook': [],
    }
    tags: Optional[List[str]] = []
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    group: Optional[Optional[str]] = None
    docs: Optional[Docs] = {'show': True, 'node_color': None}
    patch_path: Optional[Optional[str]] = None
    build_path: Optional[Optional[str]] = None
    deferred: Optional[bool] = False
    unrendered_config: Optional[Dict[str, Any]] = {}
    created_at: Optional[float] = 1686861158.804467
    config_call_dict: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[RefArgs]] = []
    sources: Optional[List[List[str]]] = []
    metrics: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    compiled_path: Optional[Optional[str]] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[Optional[str]] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[InjectedCTE]] = []
    contract: Optional[Contract] = {'enforced': False, 'checksum': None}


class SourceDefinition(BaseParserModel):
    class Config:
        extra = Extra.forbid

    database: Optional[Optional[str]] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: ResourceType9
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    source_name: str
    source_description: str
    loader: str
    identifier: str
    quoting: Optional[Quoting] = {
        'database': None,
        'schema': None,
        'identifier': None,
        'column': None,
    }
    loaded_at_field: Optional[Optional[str]] = None
    freshness: Optional[Optional[FreshnessThreshold]] = None
    external: Optional[Optional[ExternalTable]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, ColumnInfo]] = {}
    meta: Optional[Dict[str, Any]] = {}
    source_meta: Optional[Dict[str, Any]] = {}
    tags: Optional[List[str]] = []
    config: Optional[SourceConfig] = {'enabled': True}
    patch_path: Optional[Optional[str]] = None
    unrendered_config: Optional[Dict[str, Any]] = {}
    relation_name: Optional[Optional[str]] = None
    created_at: Optional[float] = 1686861158.8133152


class MetricTypeParams(BaseParserModel):
    class Config:
        extra = Extra.forbid

    measure: Optional[Optional[MetricInputMeasure]] = None
    measures: Optional[Optional[List[MetricInputMeasure]]] = None
    numerator: Optional[Optional[MetricInputMeasure]] = None
    denominator: Optional[Optional[MetricInputMeasure]] = None
    expr: Optional[Optional[str]] = None
    window: Optional[Optional[MetricTimeWindow]] = None
    grain_to_date: Optional[Optional[GrainToDateEnum]] = None
    metrics: Optional[Optional[List[MetricInput]]] = None


class Dimension(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    type: Type5
    description: Optional[Optional[str]] = None
    is_partition: Optional[bool] = False
    type_params: Optional[Optional[DimensionTypeParams]] = None
    expr: Optional[Optional[str]] = None
    metadata: Optional[Optional[SourceFileMetadata]] = None


class Metric(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    resource_type: ResourceType13
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    description: str
    label: str
    type: Type3
    type_params: MetricTypeParams
    filter: Optional[Optional[WhereFilter]] = None
    metadata: Optional[Optional[SourceFileMetadata]] = None
    meta: Optional[Dict[str, Any]] = {}
    tags: Optional[List[str]] = []
    config: Optional[MetricConfig] = {'enabled': True, 'group': None}
    unrendered_config: Optional[Dict[str, Any]] = {}
    sources: Optional[List[List[str]]] = []
    depends_on: Optional[DependsOn] = {'macros': [], 'nodes': []}
    refs: Optional[List[RefArgs]] = []
    metrics: Optional[List[List[str]]] = []
    created_at: Optional[float] = 1686861158.815338
    group: Optional[Optional[str]] = None


class SemanticModel(BaseParserModel):
    class Config:
        extra = Extra.forbid

    name: str
    resource_type: ResourceType15
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    model: str
    node_relation: Optional[Optional[NodeRelation]] = None
    description: Optional[Optional[str]] = None
    defaults: Optional[Optional[Defaults]] = None
    entities: Optional[List[Entity]] = []
    measures: Optional[List[Measure]] = []
    dimensions: Optional[List[Dimension]] = []
    metadata: Optional[Optional[SourceFileMetadata]] = None


class ManifestV10(BaseParserModel):
    class Config:
        extra = Extra.forbid

    metadata: ManifestMetadata = Field(..., description='Metadata about the manifest')
    nodes: Dict[
        str,
        Union[
            AnalysisNode,
            SingularTestNode,
            HookNode,
            ModelNode,
            RPCNode,
            SqlNode,
            GenericTestNode,
            SnapshotNode,
            SeedNode,
        ],
    ] = Field(
        ..., description='The nodes defined in the dbt project and its dependencies'
    )
    sources: Dict[str, SourceDefinition] = Field(
        ..., description='The sources defined in the dbt project and its dependencies'
    )
    macros: Dict[str, Macro] = Field(
        ..., description='The macros defined in the dbt project and its dependencies'
    )
    docs: Dict[str, Documentation] = Field(
        ..., description='The docs defined in the dbt project and its dependencies'
    )
    exposures: Dict[str, Exposure] = Field(
        ..., description='The exposures defined in the dbt project and its dependencies'
    )
    metrics: Dict[str, Metric] = Field(
        ..., description='The metrics defined in the dbt project and its dependencies'
    )
    groups: Dict[str, Group] = Field(
        ..., description='The groups defined in the dbt project'
    )
    selectors: Dict[str, Any] = Field(
        ..., description='The selectors defined in selectors.yml'
    )
    disabled: Optional[
        Optional[
            Dict[
                str,
                List[
                    Union[
                        AnalysisNode,
                        SingularTestNode,
                        HookNode,
                        ModelNode,
                        RPCNode,
                        SqlNode,
                        GenericTestNode,
                        SnapshotNode,
                        SeedNode,
                        SourceDefinition,
                        Exposure,
                        Metric,
                    ]
                ],
            ]
        ]
    ] = Field(None, description='A mapping of the disabled nodes in the target')
    parent_map: Optional[Optional[Dict[str, List[str]]]] = Field(
        None, description='A mapping from\xa0child nodes to their dependencies'
    )
    child_map: Optional[Optional[Dict[str, List[str]]]] = Field(
        None, description='A mapping from parent nodes to their dependents'
    )
    group_map: Optional[Optional[Dict[str, List[str]]]] = Field(
        None, description='A mapping from group names to their nodes'
    )
    semantic_models: Dict[str, SemanticModel] = Field(
        ..., description='The semantic models defined in the dbt project'
    )
